#define	lcd_clk_port	"B"
#define	lcd_clk_bit	1
#define	lcd_dat_port	"B"
#define	lcd_dat_bit	0
#define	lcd_ena_port	"B"
#define	lcd_ena_bit	2

;Analogeingang: pb4 (ADC2)
;LED-Ausgang: pb3

	include	/home/nutzer/eigene/prj/avr/asl/appnotes/tn45def.asm
	include	/home/nutzer/eigene/prj/avr/hilo.asm

	segment data
	org	0x60
tresh_on:	res	2
tresh_off:	res	2
	segment code

	rjmp	isr_RESET
	rjmp	isr_INT0
	rjmp	isr_PCINT0
	rjmp	isr_TIM1_COMPA
	rjmp	isr_TIM1_OVF
	rjmp	isr_TIM0_OVF
	rjmp	isr_EE_RDY
	rjmp	isr_ANA_COMP
	rjmp	isr_ADC
	rjmp	isr_TIM1_COMPB
	rjmp	isr_TIM0_COMPA
	rjmp	isr_TIM0_COMPB
	rjmp	isr_WDT
	rjmp	isr_USI_START
	rjmp	isr_USI_OVF

isr_INT0:
isr_PCINT0:
isr_WDT:
isr_TIM1_COMPA:
isr_TIM1_COMPB:
isr_TIM1_OVF:
isr_TIM0_COMPA:
isr_TIM0_COMPB:
isr_TIM0_OVF:
isr_ANA_COMP:
isr_ADC:
isr_EE_RDY:
isr_USI_START:
isr_USI_OVF:
	reti

	include tnarx.asm
	include	mul16.asm

ldez:	ldi	r17,5
ldez1:
	push	r17
	push	r18
	push	r19
	rcall	div
	pop	r19
	pop	r18
	pop	r17
	dec	r17
	brne	ldez1
	rcall	lcd_spc
	ret

adu_init:
	;Taktteiler 8
	ldi	r16,(1<<ADPS2)|(0<<ADPS1)|(0<<ADPS0)
	out	adcsra,r16
	ldi	r16,1<<4
	out	didr0,r16
	ret

adu_get:
	sbi	adcsra,aden
	ldi	r16,0b10010010	;interne 2,56V-Ref, Eingang 4
	out	admux,r16
	sbi	adcsra,adsc
adu_get1:
	sbic	adcsra,adsc
	rjmp	adu_get1
	cbi	adcsra,aden
	in	r0,adcl
	in	r1,adch
	ret

isr_RESET:
	ldi	r16,low(ramend)
	ldi	r17,high(ramend)
	out	spl,r16
	out	sph,r17
	rcall	lcd_init
	rcall	adu_init

	ldi	r16,~(1<<4)	;PB4=Adu-Eingang
	out	ddrb,r16

	ldi	r16,122		;Zeitkonstante
	out	ocr1c,r16
	dec	r16
	out	ocr1a,r16
	ldi	r16,0b10001110	;CTC + Vorteiler 8192
	out	tccr1,r16
	ldi	r16,1<<ocie1a
	out	timsk,r16
	sei
	ldi	r16,1<<se
	out	mcucr,r16

	ldi	r16,low(1000)
	ldi	r17,high(1000)
	sts	tresh_off,r16
	sts	tresh_off+1,r17
	ldi	r16,low(1200)
	ldi	r17,high(1200)
	sts	tresh_on,r16
	sts	tresh_on+1,r17
	clr	r20
	clr	r21

loop:
	rcall	adu_get
	mov	r18,r0
	mov	r19,r1
	ldi	r16,low(645)
	ldi	r17,high(645)
	rcall	mul16	;RR17 hat jetzt die Millivolt

	ldi	r24,low(2800)
	ldi	r25,high(2800)
	cp	r17,r24
	cpc	r18,r25
	brcs	nicht_li

	ldi	r16,low(2800)
	sts	tresh_off,r16
	ldi	r16,high(2800)
	sts	tresh_off+1,r16
	ldi	r16,low(4000)
	sts	tresh_on,r16
	ldi	r16,high(4000)
	sts	tresh_on+1,r16

nicht_li:
	lds	r24,tresh_off
	lds	r25,tresh_off+1
	cp	r17,r24
	cpc	r18,r25
	brcc	nicht_aus
	cbi	portb,3
nicht_aus:

	lds	r24,tresh_on
	lds	r25,tresh_on+1
	cp	r17,r24
	cpc	r18,r25
	brcs	nicht_ein
	sbi	portb,3
nicht_ein:
	mov	r24,r17
	mov	r25,r18
	sbi	port{lcd_ena_port},lcd_ena_bit
	rcall	div
	rcall	div
	rcall	div
	rcall	div
	rcall	lcd_spc
	rcall	lcd_spc
	ldi	r16,5	;linke Displayhälfte
	rcall	lcd_obyte
	cbi	port{lcd_ena_port},lcd_ena_bit

	sbi	port{lcd_ena_port},lcd_ena_bit
	mov	r24,r20
	mov	r25,r21
	rcall	ldez
	ldi	r16,4	;rechte Displayhälfte
	rcall	lcd_obyte
	cbi	port{lcd_ena_port},lcd_ena_bit
	;bis zum nächsten Timerinterrupt schlafen legen
	sleep

	sbis	portb,3
	rjmp	loop

	subi	r20,-1
	sbci	r21,-1

	rjmp	loop

	end